/*ifixf1002.h is the header file for the device depedent driver code interface */
/*
** INTEL CORPORATION PROPRIETARY INFORMATION
** This software is supplied under the terms of a license agreement or
** nondisclosure agreement with Intel Corporation and may not be copied
** or disclosed except in accordance with the terms of that agreement.
** Copyright (C) 2000 Intel Corporation. All rights Reserved.
*/
#ifndef _IFIXF1002_H_
#define _IFIXF1002_H_
typedef enum{
    SUCC,
    FAIL
} ERR_CODE;

#define INT_LOW_ALL		0xC0
#define INT_HIGH_ALL		0x77

#define	STOPE_MSK		0x40
#define OVFCE_MSK		0x20
#define	LNCHE_MSK		0x10
#define	TXOKE_MSK		0x04
#define PKEVE_MSK		0x02
#define RXOKE_MSK		0x01
#define ANERE_MSK		0x80
#define	PGRCE_MSK		0x40
#define FCT_MSK			0x01
#define TXSTT_MSK		0x20
#define TXEN_MSK		0x10			
#define RXEN_MSK		0x08
#define PTRST_MSK		0x04
#define	CTRST_MSK		0x02
#define	CNRST_MSK		0x01
#define PFLC_MSK		0x80
#define PMER_MSK		0x20
#define PRTL_MSk		0x10
#define	PSRT_MSK		0x08
#define PCRC_MSK		0x02
#define	POVF_MSK		0x01
#define	UNFS_MSK		0x01
#define	TTH_MSK			0x3F
#define	RTH_MSK			0x3F
#define FIFMD_MSK		0x18
#define	HRYD_MSK		0x04
#define PS_D_MSK		0x02
#define BEND_MSK		0x01
#define LCKE_MSK		0x80
#define	FXECD_MSK		0x40
#define ILPK_MSK		0x20
#define CPUBW_MSK		0x04
#define SDDIS_MSK		0x02
#define GPCS_MSK		0x01
#define CRCR_MSK		0x80
#define	HRPL_MSK		0x40
#define HDRS_MSK		0x3F
#define ADFC_MSK		0x20
#define	SPM_MSK			0x10
#define	XOND_MSK		0x08
#define RFLCE_MSK		0x04
#define CRCD_MSK		0x02
#define PADD_MSK		0x01
#define	TSD_MSK			0xFF
#define PTSM0_MSK		0xFF 
#define	PTSM1_MSK		0xFF
#define	MPS0_MSK		0xFF
#define MPS1_MSK    		0xFF
#define	IPG_MSK			0x1F
#define TX_OV_MSK0		0x07
#define TX_OV_MSK1		0xFE
#define TX_OV_MSK2		0x0F
#define TX_BD_MSK		0x08
#define TX_OK_MSK		0x04
#define TX_ER_MSK		0x02
#define TX_PS_MSK		0x01
#define TX_1519_MSK		0x80
#define TX_1024_MSK		0x40
#define TX_512_MSK		0x20
#define TX_256_MSK		0x10
#define TX_128_MSK		0x08
#define TX_65_MSK		0x04
#define TX_64_MSK		0x02
#define TX_BRD_MSK		0x04
#define TX_MLT_MSK		0x02
#define TX_UNI_MSK		0x01
#define RX_OV_MSK0		0xFB
#define RX_OV_MSK1		0xF7
#define RX_OV_MSK2		0x7F
#define RX_ER_MSK		0x40
#define RX_FAL_MSK		0x20
#define RX_PS_MSK		0x10
#define RX_1519_MSK		0x08
#define RX_1024_MSK		0x04
#define RX_512_MSK		0x02
#define RX_256_MSK		0x01
#define RX_128_MSK		0x80
#define RX_65_MSk		0x40
#define RX_64_MSK		0x20
#define RX_L_CR_MSK		0x10
#define	RX_L_OK_MSK		0x04
#define	RX_N_CR_MSK		0x02
#define RX_BRD_MSK		0x01
#define RX_MLT_MSK		0x80
#define RX_UNI_MSK		0x40
#define RX_S_CR_MSK		0x20
#define RX_S_OK_MSK		0x10
#define RX_OV_MSK		0x08
#define RX_BD_MSK		0x02
#define RX_OK_MSK		0x01
#define MDIO_MSK		0x80
#define MDC_MSK			0x40
#define MDCEN_MSK		0x20
#define RWGMI_MSK		0x10
#define PHY_ADD_MSK0		0x0F
#define PHY_ADD_MSK1		0x80
#define REG_ADD_MSK		0x7C
#define GMIRY_MSK		0x02
#define AMAM_MSK		0x01
#define RST_MSK			0x80
#define LPBK_MSK		0x40
#define ANENBL_MSK		0x10
#define RESAN_MSK		0x02
#define NXTPG_MSK		0x80
#define RF_MSK			0x30
#define ASM_DIR_MSK		0x01
#define PAUSE_MSK		0x80
#define GMII_CTL_RMSK0		0xC0
#define GMII_CTL_RMSK1		0xFF
#define GMII_CTL_WMSK0		0x00
#define GMII_CTL_WMSK1		0xD2
#define GMII_STT_MSK0		0x7F
#define GMII_STT_MSK1		0xFF
#define AN_ADV_MSK0		0xE0
#define AN_ADV_MSK1		0xB1
#define AN_PRT_ABL_MSK0		0xE0
#define AN_PRT_ABL_MSK1		0xF1
#define AN_EXP_MSK0		0x86
#define AN_EXP_MSK1		0x00
#define AN_NP_TR_MSK0		0xFF
#define AN_NP_TR_MSK1		0xB7
#define AN_PRT_NP_MSK0		0xFF
#define AN_PRT_NP_MSK1		0xBF
#define GMII_EXT_STT_MSK0	0x00
#define GMII_EXT_STT_MSK1	0xF0
#define GPCS_STT_MSK0		0x23
#define GOCS_STT_MSK1		0x00


#define	STOPE		6
#define OVFCE		5
#define	LNCHE		4
#define	TXOKE		2
#define PKEVE		1
#define RXOKE		0
#define ANERE		7
#define	PGRCE		6
#define FCT		0
#define TXSTT		5
#define TXEN		4			
#define RXEN		3
#define PTRST		2
#define	CTRST		1
#define	CNRST		0
#define PFLC		7
#define PMER		5
#define PRTL		4
#define	PSRT		3
#define PCRC		1	
#define	POVF		0
#define	UNFS		0
#define	TTH		0
#define	RTH		0
#define FIFMD		3
#define	HRYD		2
#define PS_D		1
#define BEND		0
#define LCKE		7
#define	FXECD		6
#define ILPK		5
#define CPUBW		2
#define SDDIS		1
#define GPCS		0
#define CRCR		7
#define	HRPL		6
#define HDRS		0
#define ADFC		5
#define	SPM		4
#define	XOND		3
#define RFLCE		2
#define CRCD		1
#define PADD		0
#define	TSD		0
#define PTSM0		0 
#define	PTSM1		0
#define	MPS0		0
#define MPS1   		0
#define	IPG		0
#define TX_BD		3
#define TX_OK		2
#define TX_ER		1
#define TX_PS		0
#define TX_1519		7
#define TX_1024		6
#define TX_512		5
#define TX_256		4
#define TX_128		3
#define TX_65		2
#define TX_64		1
#define TX_BRD		2
#define TX_MLT		1
#define TX_UNI		0
#define RX_ER		6
#define RX_FAL		5
#define RX_PS		4
#define RX_1519		3
#define RX_1024		2
#define RX_512		1
#define RX_256		0
#define RX_128		7
#define RX_65		6
#define RX_64		5
#define RX_L_CR		4
#define	RX_L_OK		2
#define	RX_N_CR		1
#define RX_BRD		0
#define RX_MLT		7
#define RX_UNI		6
#define RX_S_CR		5
#define RX_S_OK		4
#define RX_OV		3
#define RX_BD		1
#define RX_OK		0
#define MDIO		7
#define MDC		6
#define MDCEN		5
#define RWGMI		4
#define PHY_ADD0	0
#define PHY_ADD1	7
#define REG_ADD		2
#define GMIRY		1
#define AMAM		0
#define RST		7
#define LPBK		6
#define ANENBL		4
#define RESAN		1
#define NXTPG		7
#define RF		5
#define ASM_DIR		0
#define PAUSE		7



typedef enum{
    GET_INT_STATUS =0xE200,
    GET_INT_EN,
    SET_STOP_INT_EN,
    SET_OVFCE_INT_EN,
    SET_LNCHE_INT_EN,
    SET_TXOKE_INT_EN,
    SET_PKEVE_INT_EN,
    SET_RXOKE_INT_EN,
    SET_ANERE_INT_EN,
    SET_PGRCE_INT_EN,
    CL_STOP_INT_EN,
    CL_OVFCE_INT_EN,
    CL_LNCHE_INT_EN,
    CL_TXOKE_INT_EN,
    CL_PKEVE_INT_EN,
    CL_RXOKE_INT_EN,
    CL_ANERE_INT_EN,
    CL_PGRCE_INT_EN,
    CL_INT_ALL,
    SET_INT_ALL,
    GET_PORT_CTR,
    SET_PORT_CTR,
    SET_FCT,
    RESTART_XMIT,
    ENABLE_XMIT,
    DISABLE_XMIT,
    ENABLE_RX,
    DISABLE_RX,
    RESET_PORT,
    RESET_CONTROL,
    RESET_COUNTER,
    GET_ID_REV,
    GET_TX_RX_STATUS,
    GET_TX_OV_STATUS,
    GET_RX_OV_STATUS,
    GET_TX_RX_ERR,
    STOP_TRANSMITION_UNFS,
    CONT_TRANSMISSION_UNFS,
    GET_FFO_TSHD,
    GET_RX_FFO_TSHD,
    GET_TX_FFO_TSHD,
    SET_RX_FFO_TSHD,
    SET_TX_FFO_TSHD,
    GET_PORT_MODE,
    GET_FIFMD,
    SET_FIFMD,
    DISABLE_HRYD,
    ENABLE_HRYD,
    DISABLE_PS,
    ENABLE_PS,
    SET_BIG_ENDIAN,
    SET_LITTLE_ENDIAN,
    ENABLE_LOCK_SIGNAL,
    DISABLE_LOCK_SIGNAL,
    SET_FXECD,
    RESET_FXECD,
    SET_ILPK,
    CLEAR_ILPK,
    SET_CPUBW_16,
    SET_CPUBW_8,
    SET_SDDIS,
    CLEAR_SDDIS,
    SET_GPCS,
    CLEAR_GPCS,
    GET_TX_RX_PARAM,
    REMOVE_CRC,
    CLEAR_REMOVE_CRC,
    GET_HEADR_SIZE,
    SET_HEADER_SIZE,
    SET_ADFC,
    CLEAR_ADFC,
    SET_SPM,
    CLEAR_SPM,
    DISABLE_XON,
    ENABLE_XON,
    ENABLE_RFLCE,
    DISABLE_RFLCE,
    DISABLE_CRCD,
    ENABLE_CRCD,
    DISABLE_PADD,
    ENABLE_PADD,
    GET_TX_TSHD,
    SET_TX_TSHD,
    GET_PAUSE_TIME, 
    SET_PAUSE_TIME,
    GET_PKT_MAX_SIZE,
    SET_PKT_MAX_SIZE,
    GET_IPG_VAL,
    SET_IPG_VAL,
    GET_MAC_ADDR,
    SET_MAC_ADDR,
    GET_VLAN_TAG,
    SET_VLAN_TAG,
    GET_TX_OV_MASK,
    SET_TX_OV_MASK,
    GET_RX_OV_MASK,
    SET_RX_OV_MASK,
    GET_GMII_MNG_ACC,
    SET_GMII_MNG_ACC,
    GET_GMII_MNG_DAT, /*only for port 0*/
    SET_GMII_MNG_DAT, /*only for port 0*/
    GET_GMII_CTL,
    SET_GMII_CTL,
    GET_GMII_STATUS,
    GET_AN_ADV,
    SET_AN_ADV,
    GET_AN_PTR_ABL,
    GET_AN_EXP,
    GET_AN_NP_TR,
    SET_AN_NP_TR,
    GET_AN_PRT_NP, 
    GET_GMII_EXT_STT, 
    GET_GPCS_STT,
    GET_GIGA_STAT,
    GET_SNMP_STAT,
    GET_RMON_STAT,
    GET_HOST_RMON_STAT,
    GET_GIGA_CSR,    //added for testing
    RECONFIG_PORT    //added for testing
} IOCTL_CMD;

typedef struct {
    unsigned int tx_uni_ok;
    unsigned int tx_mlt_ok;
    unsigned int tx_brd_ok;
    unsigned int tx_pkt_64;
    unsigned int tx_pkt_65;
    unsigned int tx_pkt_128;
    unsigned int tx_pkt_256;
    unsigned int tx_pkt_512;
    unsigned int tx_pkt_1024;
    unsigned int tx_pkt_1519;
    unsigned int tx_pause;
    unsigned int tx_err;
    unsigned long long int tx_oct_ok;
    unsigned long long int tx_oct_bad;
    unsigned long long int rx_oct_ok;
    unsigned long long int rx_oct_bad;
    unsigned int rx_ovf;
    unsigned int rx_short_ok;
    unsigned int rx_short_crc;
    unsigned int rx_uni_ok;
    unsigned int rx_mlt_ok;
    unsigned int rx_brd_ok;
    unsigned int rx_norm_crc;
    unsigned int rx_long_ok;
    unsigned int rx_long_crc;
    unsigned int rx_pkt_64;
    unsigned int rx_pkt_65;
    unsigned int rx_pkt_128;
    unsigned int rx_pkt_256;
    unsigned int rx_pkt_512;
    unsigned int rx_pkt_1024;
    unsigned int rx_pkt_1519;
    unsigned int rx_pause;
    unsigned int rx_fals_crs;
    unsigned int rx_gpcs_err;
} IXF1002_STAT;

typedef struct {
    unsigned long long int ft_ok;
    unsigned long long int fr_ok;
    unsigned long long int fcs_err;
    unsigned long long int oct_tx_ok;
    unsigned long long int oct_rx_ok;
    unsigned long long int ftl_err;
    unsigned long long int mlt_ftx_ok;
    unsigned long long int brd_frx_ok;
    unsigned long long int mlt_frx_ok;
    unsigned long long int brd_ftx_ok;
    unsigned long long int pause_ftx;
    unsigned long long int pause_frx;
}SNMP_STAT;
 
typedef struct {
    unsigned long long int eth_st_drp_evt;
    unsigned long long int eth_st_oct;
    unsigned long long int eth_st_pkt;
    unsigned long long int eth_st_brd_pkt;
    unsigned long long int eth_st_mlt_pkt;
    unsigned long long int eth_st_crc_alg_err;
    unsigned long long int eth_st_unds_pkt;
    unsigned long long int eth_st_ovs_pkt;
    unsigned long long int eth_st_frm;
    unsigned long long int eth_st_jbr;
    unsigned long long int eth_st_64_oct;
    unsigned long long int eth_st_65_127_oct;
    unsigned long long int eth_st_128_255_oct;
    unsigned long long int eth_st_256_511_oct;
    unsigned long long int eth_st_512_1023_oct;
    unsigned long long int eth_st_1024_1518_oct;
} RMON_STAT;

typedef struct {
    unsigned long long int hst_in_pkt;
    unsigned long long int hst_out_pkt;
    unsigned long long int hst_in_oct;
    unsigned long long int hst_out_oct;
    unsigned long long int hst_out_err;
    unsigned long long int hst_out_brd_pkt;
    unsigned long long int hst_out_mlt_pkt;
} RMON_HST_STAT;

typedef struct {
    unsigned short int_stt;
    unsigned short int_en;  
    unsigned short port_ctr;
    unsigned short id_rev;
    unsigned short tx_rx_stt;
    unsigned int tx_ov_stt;
    unsigned int rx_ov_stt;
    unsigned short tx_rx_err;
    unsigned short ffo_tshd;
    unsigned short port_mode;
    unsigned short tx_rx_param;
    unsigned short tx_tshd;
    unsigned short pause_time;
    unsigned short pkt_max_size;
    unsigned short ipg_val; 
    unsigned long long int mac_add;
    unsigned short vlan_tag;
    unsigned int tx_ov_msk;
    unsigned int rx_ov_msk;
    unsigned short gmii_mng_acc;
    unsigned short gmii_mng_dat;
    unsigned short gmii_ctl;
    unsigned short gmii_stt;
    unsigned short an_adv;
    unsigned short an_prt_abl;
    unsigned short an_exp;
    unsigned short an_np_tr;
    unsigned short an_prt_np;
    unsigned short gmii_ext_stt;
    unsigned short gpcs_stt;
} IXF1002_CSR;

#endif

