/*
** INTEL CORPORATION PROPRIETARY INFORMATION
** This software is supplied under the terms of a license agreement or
** nondisclosure agreement with Intel Corporation and may not be copied
** or disclosed except in accordance with the terms of that agreement.
** Copyright (C) 2000 Intel Corporation. All rights Reserved.
*/
#include <linux/fs.h>
#include "ixf1002.h"
#include "ifixf1002.h"

int init_module (void);
void cleanup_module(void);
int giga_open(struct inode *, struct file *);
int giga_close(struct inode *, struct file *);
ssize_t giga_read(struct file *, char *, size_t, loff_t *);
ssize_t giga_write(struct file *, const char *, size_t, loff_t *);
int giga_ioctl(struct inode *, struct file *, unsigned int, unsigned long );
ERR_CODE port_create(unsigned int );
