/* ixf1002utl.h */
/*
** INTEL CORPORATION PROPRIETARY INFORMATION
** This software is supplied under the terms of a license agreement or
** nondisclosure agreement with Intel Corporation and may not be copied
** or disclosed except in accordance with the terms of that agreement.
** Copyright (C) 2000 Intel Corporation. All rights Reserved.
*/

#include "ifixf1002.h"

ERR_CODE verify_dev_id(IXF1002_CTRL_REG * );
ERR_CODE port_config(GIGA_DEV_PORT *);
void port_show(GIGA_DEV_PORT * );
void port_start(GIGA_DEV_PORT * );
void port_show_addr(GIGA_DEV_PORT * );
void ixf1002_cmd_handle(GIGA_DEV_PORT *, IOCTL_CMD cmd, void *);
void get_giga_stat(IXF1002_STAT *, IXF1002_STAT_REG *);
void get_snmp_stat(SNMP_STAT *, IXF1002_STAT *);
void get_rmon_stat(RMON_STAT *, IXF1002_STAT *);
void get_host_rmon_stat(RMON_HST_STAT *, IXF1002_STAT *);
unsigned long long int get_stat_value(unsigned int [], unsigned short);
void get_giga_csr(IXF1002_CSR *, IXF1002_CTRL_REG *); 
unsigned long long int get_csr_value(unsigned int [], unsigned short);

